#
# Crypt::Passwd
# A perl package to "crypt" passwords using Linux's style
#

package Crypt::Passwd;

sub l64a {
    my $v = shift;
    my $a = '';
    my @itoa64 = ( '.','/',0..9,'A'..'Z','a'..'z');
    for(0..3) {
        $a .= $itoa64[$v & 0x3f];
        $v >>= 6;
    }
    return $a;
}

sub gensalt {
    my $salt = l64a(int(rand(0x7fffffff)+$$));
    return $salt . l64a(time);
}

sub cryptpass {
    my $pass = shift;
    my $salt = ((shift) ? '$1$' : '') .gensalt;
    return crypt($pass,$salt);
}

sub oldcrypt ($) {
    cryptpass(shift);
}

sub newcrypt ($) {
    cryptpass(shift,1);
}
1;
