#
# Crypt::SMB v1.1.1
# A package for generate SMB password hashes
# Copyrigth (c) 2000-2004 Matias Software Group
#

package Crypt::SMB;

use strict;
use Crypt::DES ();
use Digest::MD4 1.1 ();
our $VERSION = '1.1.1';

my $DD = pack('c8',0x4b,0x47,0x53,0x21,0x40,0x23,0x24,0x25);

sub str_to_key {
    my @str = unpack('c7',shift);
    my @key;
    $key[0] = $str[0]>>1;
    $key[1] = (($str[0]&0x01)<<6) | ($str[1]>>2);
    $key[2] = (($str[1]&0x03)<<5) | ($str[2]>>3);
    $key[3] = (($str[2]&0x07)<<4) | ($str[3]>>4);
    $key[4] = (($str[3]&0x0F)<<3) | ($str[4]>>5);
    $key[5] = (($str[4]&0x1F)<<2) | ($str[5]>>6);
    $key[6] = (($str[5]&0x3F)<<1) | ($str[6]>>7);
    $key[7] = $str[6]&0x7F;
    $_ <<= 1 for @key;
    return pack('c8',@key);
}

sub E_P16 {
    my $passwd = pack('a14',uc(shift));
    my $k1 = substr($passwd,0,7,'');
    return uc(unpack('H32',
	Crypt::DES->new(str_to_key($k1))->encrypt($DD) . # first 7
	Crypt::DES->new(str_to_key($passwd))->encrypt($DD) # rest
    ));
}

sub E_md4hash {
    my $passwd = shift;
    substr($passwd,128) = '' if(length $passwd) > 128;
    return uc(Digest::MD4->hexhash(pack 'S*',unpack 'C*',$passwd));
}

sub lm_nt_hash {
    return E_P16($_[0]),E_md4hash($_[0]);
}
