package GranJefe;
use 5.032;
use utf8;
use strict;
use warnings FATAL => 'all';

BEGIN {
    die "This module is only for Apache2 mod_perl\n" unless exists $ENV{MOD_PERL};
    $GJ::InsideApache = 1;
    require Apache2::ServerUtil;
    require Apache2::ServerRec;
    require Apache2::Request;
    $GJ::MainServer = Apache2::ServerUtil->server;
    @GJ::PerlConfig = (
        'PerlOpenLogsHandler GJ::CServices::_OpenLogs',
    );
}

use Config;
use lib ((my $lib = $Config{archlib}) =~ s|perl5|GranJefe/plib|r);

use Apache2::Const qw(:override :cmd_how);
use Apache2::CmdParms ();
use Apache2::Module ();
use Apache2::Directive ();
use Data::Dumper;

my @directives = (
    {
        name => 'DynConf',
        func => __PACKAGE__ . '::DynConf',
        req_override => RSRC_CONF,
        args_how => TAKE1,
        errmsg => 'DynConf On|Off|Full'
    },
    {
        name => 'GJModule',
        req_override => RSRC_CONF,
        args_how    => RAW_ARGS
    },
    {
       name         => '<GJModuleConf',
       func         => 'GJGenericConf',
       req_override => RSRC_CONF,
       args_how     => RAW_ARGS,
       errmsg       => '<GJModuleConf [ModuleName]...',
       cmd_data     => 'GJMC'
    },
    {
       name         => '<GJFrameworkConf',
       func         => 'GJGenericConf',
       req_override => RSRC_CONF,
       args_how     => RAW_ARGS,
       errmsg       => '<GJFrameworkConf',
       cmd_data     => 'GJFW'
    },
);
sub GJModule {
    my ($self, $parms, $args) = @_;
    my $svr_cfg = Apache2::Module::get_config($self, $parms->server);
    push(@{$svr_cfg->{GJModules}}, $args);
}
my %typeDesc = (
    GJMC => 'ModuleName',
    GJFW => 'Subsystem'
);
sub GJGenericConf {
    my ($self, $parms, $args) = @_;
    my $svr_cfg = Apache2::Module::get_config($self, $parms->server);
    my $type = $parms->info;
    my $dir= $parms->directive;
    my $fn = $dir->filename;
    my $ln = $dir->line_num;
    $args =~ s/>$//;
    my($mn, $mode) = split(' ', $args);
    die sprintf "error: No $typeDesc{$type} found at $fn, $ln\n" unless $mn;
    my $content = $svr_cfg->{$type}{$mn} ||= {};
    my $ncont;
    if(($mode||'raw') eq 'raw') {
        $ncont = eval qq|# line $ln "$fn"\n{| . $dir->as_string . '}';
    }
    $content->{$_} = $ncont->{$_} for keys %$ncont;
    #warn "$mn use " . Dumper $content;
}

sub DynConf {
    my ($self, $parms, $mode) = @_;
    my $dir = $parms->directive;
    die sprintf "  Dynconf $mode not valid. Should be On|Off|Full\n"
        unless $mode =~ /^(:?On|Off|Full)$/i;
    my $svr = $parms->server;
    my $svr_cfg = Apache2::Module::get_config($self, $svr);
    $svr_cfg->{DynaConf} = $self->{DynaConf} = $mode;
    if(!$svr->is_virtual && defined &GJ::Dynaconf::DynConf) {
        GJ::Dynaconf::DynConf($svr_cfg, lc $mode, $svr);
    } else {
        # Why?
    }
}

# The next two will be called in the order show when any of my directives are seen
# $params are from that directive
sub DIR_CREATE {
    my ($class, $parms) = @_;
    #warn "ATDC: $class\n";
    return bless {
        name => 'DIR '.__PACKAGE__,
    }, $class;
}
sub SERVER_CREATE {
    my ($class, $parms) = @_;
    my $svr = $parms->server;
    my $sn = $svr->server_hostname || 'base';
    my $is_virt = $svr->is_virtual;
    #warn "ATSC: $class $sn $is_virt\n";
    local $GJ::BPRM = $parms;
    require Bootstrap if !$is_virt;
    return bless {
            name => __PACKAGE__,
            shn => $sn,
            GJMC => {},
            GJFW => {},
            GJModules => [],
            DynaConf => -1
    }, $class;
}
sub SERVER_MERGE {
    my ($base, $child) = @_;
    warn "ATSM unimplemented yet, report!: $base\n";
}
sub DIR_MERGE {
    my ($base, $child) = @_;
    warn "ATDM unimplemented yet, report!: $base\n";
}

Apache2::Module::add(__PACKAGE__, \@directives);

1;
