var currDir;
var server;
var fileSpec;
var dir;
var dirs;
var styleSheets = [];
var path;
var container;
var cookie;

function onStart() {
  path = document.getElementById('path');
  container = document.getElementById('container');

  initStyleSheets();

  var lastLocation = document.getCookie(cookie, 0);
  var dirToShow = ((lastLocation != null) && isSubdir(lastLocation, dir)) ? lastLocation : dir;

  _load(dirToShow);
}

function initStyleSheets () {
  var selector = document.getElementById('styleSelector');
  var links = document.getElementsByTagName('link');
  var i, prefered = document.getCookie('gjjsf_sfs',0);

  for(i=0; i<links.length; i++) {
    if(links[i].getAttribute('rel').indexOf('style') == -1) continue;
    var title = links[i].getAttribute('title');
    if(!title) continue;

    styleSheets.push(links[i]);
    var opt = new Option(title, title);
    selector.options[selector.options.length] = opt;

    if(prefered) links[i].disabled = !(title == prefered);
    if(!links[i].disabled) opt.selected = true;
  }

}

function changeStylesheet (title) {
  var i;

  for(var i=0; i<styleSheets.length; i++)
    styleSheets[i].disabled = !(styleSheets[i].getAttribute('title') == title);

  document.setCookie('gjjsf_sfs', title);
}

function clearElement (element) {
  while(element.lastChild)
    element.removeChild(element.lastChild);
}

function _load(url) {
  clearElement(container);
  clearElement(path);
  currDir = url;
  if(currDir[currDir.length-1]!='/') currDir += '/';
  document.setCookie(cookie, currDir);
  new GJ.Request(app, 'http://' + server + currDir, this).send();
};

function gotoDir(last) {
  var d = '/';
  var i;
  for(i=0;i<=last;i++) {
    if(dirs[i]=='') continue;
    d+=dirs[i]+'/';
  }
  return d;
}

function addDirMenu() {
  var i, button;

  for(i=0; i<dirs.length; i++) {
    if(dirs[i] == '') continue;
    button = document.createElementEx('button',
				      {onclick : "_load(gotoDir("+i+"))"} );
    var text = document.createTextNode(dirs[i]);
    button.appendChild(text);
    path.appendChild(button);
  }

  button.className += ' last';
}

this.onReady = function (req) {
  if(!window.frames['_parser'])
    document.body.appendChild(this.app.window.document.createElementEx('IFRAME', {style:{display:'none'}, name:'_parser'}));

  window.frames['_parser'].document.open('text/html');
  window.frames['_parser'].document.write(req.result.html);
  window.frames['_parser'].document.close();

  var aS = window.frames['_parser'].document.getElementsByTagName('a');

  dirs = currDir.split('/');
  addDirMenu();

  var empty = true;
  var i;

  addEntry.par = true;
  for(i=0;i<aS.length;i++) {
    var h = aS[i].getAttribute('href');

    if(!h) continue;

    if(h.charAt(0) == '?') continue;

    if(h.charAt(0) == '/') continue;

    if(fileSpec &&
       fileSpec != '' &&
       !h.match(new RegExp(this.fileSpec)))
      continue;

    addEntry(h);
    empty = false;
  }

  if(empty)
    container.appendChild(document.createTextNode("No files"));
};

function addEntry(item) {
  var isDir = item.charAt(item.length-1) == '/';
  var isAbsolute = item.charAt(0) == '/';

  addEntry.par = !addEntry.par;
  var e = document.createElementEx('div',{className:'box '+(addEntry.par?'par ':'non ')+(isDir?'dir':'file')});
  var s = document.createElement('span');
  var text = document.createTextNode(unescape(item));
  s.appendChild(text);
  e.appendChild(s);
  container.appendChild(e);

  if(isDir) {
    e.onclick = function () {
      _load(currDir + '/' + item);
    };
  } else {
    e.onclick = function () {
      if(confirm('¿Seleccionar ' + currDir + item + '?')) {
	setValue(currDir + item);
	window.close();
      }
    }
    e.ondblclick = function () {
      GJ.newWindowMulti(currDir+item,'viewer',480,640);
    }
  }
}

function isSubdir (sub, dir) {
  return (sub.indexOf(dir) == 0);
}
